Bug 1186497 - Review Request: libtifiles2 - Texas Instruments calculator files library
Summary: Review Request: libtifiles2 - Texas Instruments calculator files library
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Mario Blättermann
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1186494
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-01-27 19:32 UTC by Ben Rosser
Modified: 2015-05-10 23:58 UTC (History)
3 users (show)

Fixed In Version: libtifiles2-1.1.6-4.fc21
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-05-10 23:33:56 UTC
mario.blaettermann: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Ben Rosser 2015-01-27 19:32:52 UTC
Spec URL: https://tc01.fedorapeople.org/tilp2/libtifiles2.spec
SRPM URL: https://tc01.fedorapeople.org/tilp2/libtifiles2-1.1.6-0.fc21.src.rpm
Description: The tifiles library is a library capable of reading, modifying,
and writing TI formatted files. It can also group/ungroup files.
This library is able to manipulate files in a fairly transparent
fashion. With this library, the developer does not have to worry
about the different file formats.
Fedora Account System Username: tc01

A general disclaimer: there's a lot of changelog at the bottom of this spec file. That's because two years ago (approximately), I was not a sponsored Fedora packager and the tilp2 software and its libraries were not compliant with Fedora packaging guidelines. I wrote these spec files and worked with the maintainers to fix these bugs.

Now that the major problems have been fixed, I'd like to try to actually get these RPMs into Fedora.

Comment 1 Mario Blättermann 2015-02-06 17:33:37 UTC
%lang(fr) %{_datadir}/locale/fr/LC_MESSAGES/libtifiles2.mo

Instead of adding the translation files manually (even when it is only one file) you have to use the find_lang macro:
http://fedoraproject.org/wiki/Packaging:Guidelines#Handling_Locale_Files

BuildRequires:  libticonv-devel
This is unresolvable. This package is only available from CalcForge:
http://repo.calcforge.org/fedora/21/SRPMS/repoview/libticonv.html
Well, it is currently under review for official inclusion, that's why I add that review ticket as a blocker.

The other dependency (tfdocgen) has already been added as a blocker for libticonv.

Comment 2 Mario Blättermann 2015-02-15 15:34:31 UTC
Taking this for a full review once libticonv has been built for Rawhide.

Comment 3 Mario Blättermann 2015-02-18 10:26:35 UTC
libticonv is now available from Rawhide, you may continue.

(In reply to Mario Blättermann from comment #1)
> %lang(fr) %{_datadir}/locale/fr/LC_MESSAGES/libtifiles2.mo
> 
> Instead of adding the translation files manually (even when it is only one
> file) you have to use the find_lang macro:
> http://fedoraproject.org/wiki/Packaging:Guidelines#Handling_Locale_Files

Comment 4 Ben Rosser 2015-02-23 22:32:44 UTC
Added new documentation subpackage and fixed a few other things:

Spec: https://tc01.fedorapeople.org/tilp2/libtifiles2.spec
SRPM: https://tc01.fedorapeople.org/tilp2/libtifiles2-1.1.6-1.fc21.src.rpm

Comment 5 Mario Blättermann 2015-02-24 19:27:40 UTC
Have a look at the guidelines about how to handle locale files:
http://fedoraproject.org/wiki/Packaging:Guidelines#Handling_Locale_Files

Comment 6 Ben Rosser 2015-02-24 20:31:10 UTC
Oops, sorry, I missed the locale comment. Fixed, also cleaned up some end of line encodings.

Spec: https://tc01.fedorapeople.org/tilp2/libtifiles2.spec
SRPM: https://tc01.fedorapeople.org/tilp2/libtifiles2-1.1.6-2.fc21.src.rpm

Comment 7 Mario Blättermann 2015-02-25 20:14:55 UTC
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=9072904

$ rpmlint -i -v *
libtifiles2.src: I: checking
libtifiles2.src: W: spelling-error %description -l en_US tifiles -> ti files, ti-files, stifles
The value of this tag appears to be misspelled. Please double-check.

libtifiles2.src: W: spelling-error %description -l en_US ungroup -> grouping, group, roundup
The value of this tag appears to be misspelled. Please double-check.

libtifiles2.src: I: checking-url https://sourceforge.net/projects/tilp/ (timeout 10 seconds)
libtifiles2.src: I: checking-url http://sourceforge.net/projects/tilp/files/tilp2-linux/tilp2-1.17/libtifiles2-1.1.6.tar.bz2 (timeout 10 seconds)
libtifiles2.x86_64: I: checking
libtifiles2.x86_64: W: spelling-error %description -l en_US tifiles -> ti files, ti-files, stifles
The value of this tag appears to be misspelled. Please double-check.

libtifiles2.x86_64: W: spelling-error %description -l en_US ungroup -> grouping, group, roundup
The value of this tag appears to be misspelled. Please double-check.

libtifiles2.x86_64: I: checking-url https://sourceforge.net/projects/tilp/ (timeout 10 seconds)
libtifiles2-debuginfo.x86_64: I: checking
libtifiles2-debuginfo.x86_64: I: checking-url https://sourceforge.net/projects/tilp/ (timeout 10 seconds)
libtifiles2-devel.x86_64: I: checking
libtifiles2-devel.x86_64: W: spelling-error %description -l en_US libtifiles -> lifestyles
The value of this tag appears to be misspelled. Please double-check.

libtifiles2-devel.x86_64: I: checking-url https://sourceforge.net/projects/tilp/ (timeout 10 seconds)
libtifiles2-devel.x86_64: W: only-non-binary-in-usr-lib
There are only non binary files in /usr/lib so they should be in /usr/share.

libtifiles2-devel.x86_64: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

libtifiles2-doc.x86_64: I: checking
libtifiles2-doc.x86_64: I: checking-url https://sourceforge.net/projects/tilp/ (timeout 10 seconds)
libtifiles2.spec: I: checking
libtifiles2.spec: I: checking-url http://sourceforge.net/projects/tilp/files/tilp2-linux/tilp2-1.17/libtifiles2-1.1.6.tar.bz2 (timeout 10 seconds)
5 packages and 1 specfiles checked; 0 errors, 7 warnings.

Rpmlint is quite silent.



---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
    GPLv2+
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %license.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
    $ sha256sum *
    ec4d6acd1d135ee04256d04a5e1512c1ccaf82ad01e48f5e24d5c4da31ce898f  libtifiles2-1.1.6.tar.bz2
    ec4d6acd1d135ee04256d04a5e1512c1ccaf82ad01e48f5e24d5c4da31ce898f  libtifiles2-1.1.6.tar.bz2.orig

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[X] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[.] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[.] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[+] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[.] MUST: Static libraries must be in a -static package.
[+] MUST: Development files must be in a -devel package.
[+] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
[+] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[+] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. 
[+] MUST: All filenames in rpm packages must be valid UTF-8.


[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[.] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
    See Koji build above (which uses Mock anyway).
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[.] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[X] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[+] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[.] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.



There are still a few issues:

You are using %find_lang for the locale files, that's OK so far. But the pre-compiled *.gmo file gets installed. Please add "gettext" to BuildRequires and remove the *.gmo file(s) in %prep. Then the *.mo should get created from the source file (*.po) and installed.

The -doc package depends on the main package, that's somewhat unusual. Normally that package doesn't need the library to function, it's just a bunch of HTML files with pictures and stylesheets which can be viewed with any web browser. So it doesn't make sense to force the user to install the library, maybe he wants to read the docs only. Just drop the requirement, and then move the license file within the -doc package to %license. Here's the current content:

$ rpm -qpl libtifiles2-doc-1.1.6-2.fc23.x86_64.rpm
/usr/share/doc/libtifiles2
/usr/share/doc/libtifiles2/AUTHORS
/usr/share/doc/libtifiles2/COPYING
/usr/share/doc/libtifiles2/ChangeLog
/usr/share/doc/libtifiles2/README
/usr/share/doc/libtifiles2/html
/usr/share/doc/libtifiles2/html/api.html
/usr/share/doc/libtifiles2/html/api_.html
/usr/share/doc/libtifiles2/html/clean.bat
/usr/share/doc/libtifiles2/html/comments.c.html
/usr/share/doc/libtifiles2/html/constant-s.gif
/usr/share/doc/libtifiles2/html/constant.gif
/usr/share/doc/libtifiles2/html/error.c.html
/usr/share/doc/libtifiles2/html/faq.html
/usr/share/doc/libtifiles2/html/filesxx.c.html
/usr/share/doc/libtifiles2/html/filetypes.c.html
/usr/share/doc/libtifiles2/html/function-s.gif
/usr/share/doc/libtifiles2/html/function.gif
/usr/share/doc/libtifiles2/html/gnugpl.html
/usr/share/doc/libtifiles2/html/grouped.c.html
/usr/share/doc/libtifiles2/html/header.gif
/usr/share/doc/libtifiles2/html/headers.html
/usr/share/doc/libtifiles2/html/htlib.html
/usr/share/doc/libtifiles2/html/index.html
/usr/share/doc/libtifiles2/html/info.gif
/usr/share/doc/libtifiles2/html/info.html
/usr/share/doc/libtifiles2/html/langext-s.gif
/usr/share/doc/libtifiles2/html/langext.gif
/usr/share/doc/libtifiles2/html/misc.c.html
/usr/share/doc/libtifiles2/html/style.css
/usr/share/doc/libtifiles2/html/tifiles.c.html
/usr/share/doc/libtifiles2/html/tifiles.h.html
/usr/share/doc/libtifiles2/html/tigroup.c.html
/usr/share/doc/libtifiles2/html/type-s.gif
/usr/share/doc/libtifiles2/html/type.gif
/usr/share/doc/libtifiles2/html/type2str.c.html
/usr/share/doc/libtifiles2/html/typesxx.c.html
/usr/share/doc/libtifiles2/html/variable-s.gif
/usr/share/doc/libtifiles2/html/variable.gif
/usr/share/doc/libtifiles2/html/ve_fp.c.html


BTW, the -doc package needs to be noarch.


Moreover, there's something wrong with the docs included in the main package. The HTML files (which actually only should be in the -docs package) are also present there, and COPYING is also included in %doc. Needs to be investigated, here's the current content:

$ rpm -qpl libtifiles2-1.1.6-2.fc23.x86_64.rpm
/usr/lib64/libtifiles2.so.9
/usr/lib64/libtifiles2.so.9.0.2
/usr/share/doc/libtifiles2
/usr/share/doc/libtifiles2/AUTHORS
/usr/share/doc/libtifiles2/COPYING
/usr/share/doc/libtifiles2/ChangeLog
/usr/share/doc/libtifiles2/README
/usr/share/doc/libtifiles2/html
/usr/share/doc/libtifiles2/html/api.html
/usr/share/doc/libtifiles2/html/api_.html
/usr/share/doc/libtifiles2/html/clean.bat
/usr/share/doc/libtifiles2/html/comments.c.html
/usr/share/doc/libtifiles2/html/constant-s.gif
/usr/share/doc/libtifiles2/html/constant.gif
/usr/share/doc/libtifiles2/html/error.c.html
/usr/share/doc/libtifiles2/html/faq.html
/usr/share/doc/libtifiles2/html/filesxx.c.html
/usr/share/doc/libtifiles2/html/filetypes.c.html
/usr/share/doc/libtifiles2/html/function-s.gif
/usr/share/doc/libtifiles2/html/function.gif
/usr/share/doc/libtifiles2/html/gnugpl.html
/usr/share/doc/libtifiles2/html/grouped.c.html
/usr/share/doc/libtifiles2/html/header.gif
/usr/share/doc/libtifiles2/html/headers.html
/usr/share/doc/libtifiles2/html/htlib.html
/usr/share/doc/libtifiles2/html/index.html
/usr/share/doc/libtifiles2/html/info.gif
/usr/share/doc/libtifiles2/html/info.html
/usr/share/doc/libtifiles2/html/langext-s.gif
/usr/share/doc/libtifiles2/html/langext.gif
/usr/share/doc/libtifiles2/html/misc.c.html
/usr/share/doc/libtifiles2/html/style.css
/usr/share/doc/libtifiles2/html/tifiles.c.html
/usr/share/doc/libtifiles2/html/tifiles.h.html
/usr/share/doc/libtifiles2/html/tigroup.c.html
/usr/share/doc/libtifiles2/html/type-s.gif
/usr/share/doc/libtifiles2/html/type.gif
/usr/share/doc/libtifiles2/html/type2str.c.html
/usr/share/doc/libtifiles2/html/typesxx.c.html
/usr/share/doc/libtifiles2/html/variable-s.gif
/usr/share/doc/libtifiles2/html/variable.gif
/usr/share/doc/libtifiles2/html/ve_fp.c.html
/usr/share/licenses/libtifiles2
/usr/share/licenses/libtifiles2/COPYING
/usr/share/locale/fr/LC_MESSAGES/libtifiles2.mo

Comment 8 Ben Rosser 2015-02-28 04:44:27 UTC
Spec: https://tc01.fedorapeople.org/tilp2/libtifiles2.spec
SRPM: https://tc01.fedorapeople.org/tilp2/libtifiles2-1.1.6-3.fc21.src.rpm

Fixed the gettext/*.gmo stuff; the prebuilt file is now removed in %prep and rebuilt during %build.

The doc subpackage no longer depends on the package itself and also is now noarch.

I investigated the documentation stuff. Turns out that there's a bug (?) in using both relative paths in %doc and copying files directly into %{_pkgdocdir}, according to here: https://fedoraproject.org/wiki/User:Tibbs/DocdirDraft#Documentation. I fixed this, and also discovered why COPYING was winding up in the documentation directory- the documentation makefile, when running "make docs install", installs the COPYING/README/ChangeLog documentation as well as the HTML documentation. Whoops. This was easy to fix.

So that should all be better now.

Comment 9 Mario Blättermann 2015-03-01 18:27:12 UTC
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=9109316

$ rpmlint -i -v *
libtifiles2.src: I: checking
libtifiles2.src: W: spelling-error %description -l en_US tifiles -> ti files, ti-files, stifles
The value of this tag appears to be misspelled. Please double-check.

libtifiles2.src: W: spelling-error %description -l en_US ungroup -> grouping, group, roundup
The value of this tag appears to be misspelled. Please double-check.

libtifiles2.src: I: checking-url https://sourceforge.net/projects/tilp/ (timeout 10 seconds)
libtifiles2.src: I: checking-url http://sourceforge.net/projects/tilp/files/tilp2-linux/tilp2-1.17/libtifiles2-1.1.6.tar.bz2 (timeout 10 seconds)
libtifiles2.x86_64: I: checking
libtifiles2.x86_64: W: spelling-error %description -l en_US tifiles -> ti files, ti-files, stifles
The value of this tag appears to be misspelled. Please double-check.

libtifiles2.x86_64: W: spelling-error %description -l en_US ungroup -> grouping, group, roundup
The value of this tag appears to be misspelled. Please double-check.

libtifiles2.x86_64: I: checking-url https://sourceforge.net/projects/tilp/ (timeout 10 seconds)
libtifiles2-debuginfo.x86_64: I: checking
libtifiles2-debuginfo.x86_64: I: checking-url https://sourceforge.net/projects/tilp/ (timeout 10 seconds)
libtifiles2-devel.x86_64: I: checking
libtifiles2-devel.x86_64: W: spelling-error %description -l en_US libtifiles -> lifestyles
The value of this tag appears to be misspelled. Please double-check.

libtifiles2-devel.x86_64: I: checking-url https://sourceforge.net/projects/tilp/ (timeout 10 seconds)
libtifiles2-devel.x86_64: W: invalid-url URL: https://sourceforge.net/projects/tilp/ timed out
The value should be a valid, public HTTP, HTTPS, or FTP URL.

libtifiles2-devel.x86_64: W: only-non-binary-in-usr-lib
There are only non binary files in /usr/lib so they should be in /usr/share.

libtifiles2-devel.x86_64: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

libtifiles2-doc.noarch: I: checking
libtifiles2-doc.noarch: I: checking-url https://sourceforge.net/projects/tilp/ (timeout 10 seconds)
libtifiles2.spec: I: checking
libtifiles2.spec: I: checking-url http://sourceforge.net/projects/tilp/files/tilp2-linux/tilp2-1.17/libtifiles2-1.1.6.tar.bz2 (timeout 10 seconds)
5 packages and 1 specfiles checked; 0 errors, 8 warnings.


Ignorable spelling errors. Besides that, a only-non-binary warning, but we have only a pkgconfig file and a symlink in the -devel package, no header files, so that is OK. The SF website is also OK, don't know why rpmlint got a timeout.

The problems mentioned in comment #7 have been solved. The file structure in both main and doc package is OK now.

PACKAGE APPROVED.

Comment 10 Ben Rosser 2015-03-04 18:30:58 UTC
Thanks for the review!

New Package SCM Request
=======================
Package Name: libtifiles2
Short Description: Texas Instruments calculator files library
Upstream URL: https://sourceforge.net/projects/tilp/
Owners: tc01
Branches: f20 f21 f22
InitialCC:

Comment 11 Gwyn Ciesla 2015-03-04 18:38:34 UTC
Git done (by process-git-requests).

Comment 12 Fedora Update System 2015-04-27 14:39:36 UTC
libtifiles2-1.1.6-4.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/libtifiles2-1.1.6-4.fc21

Comment 13 Fedora Update System 2015-04-27 14:40:13 UTC
libtifiles2-1.1.6-4.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/libtifiles2-1.1.6-4.fc20

Comment 14 Fedora Update System 2015-04-27 14:42:19 UTC
libtifiles2-1.1.6-4.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/libtifiles2-1.1.6-4.fc22

Comment 15 Fedora Update System 2015-04-28 12:57:33 UTC
libtifiles2-1.1.6-4.fc20 has been pushed to the Fedora 20 testing repository.

Comment 16 Fedora Update System 2015-05-10 23:33:56 UTC
libtifiles2-1.1.6-4.fc22 has been pushed to the Fedora 22 stable repository.

Comment 17 Fedora Update System 2015-05-10 23:58:40 UTC
libtifiles2-1.1.6-4.fc21 has been pushed to the Fedora 21 stable repository.


Note You need to log in before you can comment on or make changes to this bug.